/*-
 * Copyright (c) 2004 Patrick Mauritz <oxygene@openbios.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct fpkfile {
	signed int offset;
	signed int size;
	char* directory;
	char* name;
};

struct fpkmeta {
	char shortname[13];
	char longname[64];
	char author[36];
	char* rootpath;
	unsigned int size;
	struct fpkfile* files;
	
	FILE* fpk;
	signed int iter;
	signed int numfiles;
};

signed int fpkinit(struct fpkmeta*, const char*);
void fpkgetdir(struct fpkmeta*);
void fpkclose(struct fpkmeta*);

void fpkrewind(struct fpkmeta*);
struct fpkfile* fpknextfile(struct fpkmeta*);
struct fpkfile* fpknextdir(struct fpkmeta*);
unsigned char* fpkgetfile(struct fpkmeta*, struct fpkfile*);
